'use strict';

var BrowserOnly = require('@docusaurus/BrowserOnly');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var BrowserOnly__default = /*#__PURE__*/_interopDefaultLegacy(BrowserOnly);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".docusaurus-plugin-drawio {\r\n  width: 100%;\r\n  padding: 10px;\r\n  border: 1px solid #ccc;\r\n  text-align: center;\r\n  overflow-x: auto;\r\n}\r\n\r\nhtml[data-theme='dark'] .docusaurus-plugin-drawio {\r\n  background-color: #333;\r\n  color: #fff;\r\n}\r\n\r\n.docusaurus-plugin-drawio > div {\r\n  margin-left: auto;\r\n  margin-right: auto;\r\n  border: 1px solid transparent;\r\n  min-width: 180px;\r\n}\r\n";
styleInject(css_248z);

/* eslint-disable @typescript-eslint/no-non-null-assertion */
var Drawio = function (_a) {
    var content = _a.content;
    console.log('content', content);
    var _b = React.useState('loading...'), tip = _b[0], setTip = _b[1];
    var el = React.useRef(null);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    var GraphViewer = window.GraphViewer;
    React.useEffect(function () {
        if (!GraphViewer) {
            setTip('GraphViewer is not loaded');
            return;
        }
        if (!content) {
            setTip('drawio file is empty');
            return;
        }
        var data = {
            editable: '_blank',
            highlight: '#0000ff',
            nav: true,
            resize: true,
            toolbar: 'zoom lightbox',
            xml: content,
        };
        var json = JSON.stringify(data);
        el.current.dataset.mxgraph = json;
        setTip('');
        setTimeout(function () {
            GraphViewer.createViewerForElement(el.current);
        }, 0);
    }, []);
    return (React__default["default"].createElement("div", { className: "docusaurus-plugin-drawio" },
        React__default["default"].createElement("div", { className: "docusaurus-plugin-drawio__content", ref: el }, tip)));
};
var Wrapper = function (_a) {
    var content = _a.content;
    return (React__default["default"].createElement(BrowserOnly__default["default"], { fallback: React__default["default"].createElement(React__default["default"].Fragment, null, "loading...") }, function () { return React__default["default"].createElement(Drawio, { content: content }); }));
};
var drawio = React.memo(Wrapper);

module.exports = drawio;
